#ifndef RESULTMANAGER_H
#define RESULTMANAGER_H

#include<map>

class ResultSet
{
    private :
    struct Result{
        int expected;
        int readed;
        int stucked;
    };

    public :
    struct Stats{
        int ok;
        int stucked;
        int lost;
        int error;
        Stats() : ok(0), stucked(0), lost (0), error(0){};
        Stats& operator +=(const Stats& toAdd);
    };

    public:
        ResultSet();
        virtual ~ResultSet();

    protected:
        std::map<int,Result> compiledData;

    public:
        void expected(int id,int nb);
        void addResult(int resultToAdd);
        void addStucked(int resultToAdd);
        Stats calculateStats();

    protected :
        void createResultIfNeeded(int resultToAdd);
};

#endif // RESULTMANAGER_H
