#ifndef YAMANWRITINGTHREADFUNCTO987568675
#define YAMANWRITINGTHREADFUNCTO987568675

#include "fifos.h"


#include <boost/thread.hpp>

class WritingThreadFunctor{
protected :
    Fifo<int>& fifo;
    int id;
    int writenNb;
    bool& hasToWrite;
    boost::barrier& goFlag;
    boost::barrier& stopFlag;
    boost::barrier& waitToEnd;
    int waitingTimeAfterWriteMillisec;

public :
    WritingThreadFunctor(Fifo<int>& newFifo, int newId, boost::barrier& newGoFlag, boost::barrier& newStopFlag, boost::barrier& newWaitToEnd, bool& newHasToWrite, int newWaitingTimeAfterWriteMillisec);
    void operator()();
    int getWritenNb();
    int getId();
};

#endif //YAMANWRITINGTHREADFUNCTO987568675
