#ifndef YAMANREADINGTHREADFUNCTOR9657654
#define YAMANREADINGTHREADFUNCTOR9657654

#include "fifos.h"
#include <boost/thread.hpp>

class ReadingThreadFunctor{
protected :
    Fifo<int>& fifo;
    std::list<int> allIdReturned;
    boost::barrier& goFlag;
    boost::barrier& waitToEnd;
    bool& hasToRead;
    int waitingTimeIfFifoIsEmptyMillisec;

public :
    ReadingThreadFunctor(Fifo<int>& newFifo, boost::barrier& newGoFlag, boost::barrier& newWaitToEnd, bool& newHasToRead, int newWaitingTimeIfFifoIsEmptyMillisec);
    void operator()();
    const std::list<int>& results();
};

#endif //YAMANREADINGTHREADFUNCTOR9657654
